package ctbrec.sites.bonga;

import com.iheartradio.m3u8.*;
import com.iheartradio.m3u8.data.MasterPlaylist;
import com.iheartradio.m3u8.data.Playlist;
import com.iheartradio.m3u8.data.PlaylistData;
import com.iheartradio.m3u8.data.StreamInfo;
import ctbrec.AbstractModel;
import ctbrec.Config;
import ctbrec.io.HtmlParser;
import ctbrec.io.HttpException;
import ctbrec.recorder.download.StreamSource;
import okhttp3.FormBody;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;
import org.json.JSONObject;
import org.jsoup.nodes.Element;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.IOException;
import java.io.InputStream;
import java.util.*;
import java.util.concurrent.ExecutionException;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import static ctbrec.ErrorMessages.HTTP_RESPONSE_BODY_IS_NULL;
import static ctbrec.Model.State.*;
import static ctbrec.io.HttpConstants.*;

public class BongaCamsModel extends AbstractModel {

    private static final String ARGS = "args[]";
    private static final Logger LOG = LoggerFactory.getLogger(BongaCamsModel.class);
    private static final String SUCCESS = "success";
    private static final String STATUS = "status";

    private static final Pattern ONLINE_BADGE_REGEX = Pattern.compile("class=\"badge_online\s*\"");

    private boolean online = false;
    private final transient List<StreamSource> streamSources = new ArrayList<>();
    private int[] resolution;

    @Override
    public boolean isOnline(boolean ignoreCache) throws IOException, ExecutionException, InterruptedException {
        if (ignoreCache) {
            boolean modelIsConnected = basicOnlineCheck();
            if (!modelIsConnected) {
                onlineState = OFFLINE;
                online = false;
                return false;
            }

            return completeOnlineCheck();
        }
        return online;
    }

    private boolean completeOnlineCheck() throws IOException {
        JSONObject roomData = getRoomData();
        if (!roomData.has("performerData")) {
            onlineState = UNKNOWN;
            return false;
        }
        JSONObject performerData = roomData.getJSONObject("performerData");
        setDisplayName(performerData.optString("displayName"));
        String chatType = performerData.optString("showType");
        boolean isAway = performerData.optBoolean("isAway");

        onlineState = mapState(chatType);
        if (onlineState == ONLINE) {
            if (isStreamAvailable()) {
                if (isAway) {
                    onlineState = AWAY;
                    online = false;
                } else {
                    online = true;
                }
            } else {
                online = false;
                onlineState = AWAY;
            }
        } else {
            online = false;
        }
        return online;
    }

    private boolean basicOnlineCheck() {
        try {
            String url = site.getBaseUrl() + "/profile/" + getName().toLowerCase();
            Request req = newRequestBuilder().url(url).build();
            try (Response resp = site.getHttpClient().execute(req)) {
                if (resp.isSuccessful()) {
                    String body = Objects.requireNonNull(resp.body(), HTTP_RESPONSE_BODY_IS_NULL).string();
                    Matcher m = ONLINE_BADGE_REGEX.matcher(body);
                    return m.find();
                } else {
                    return false;
                }
            }
        } catch (Exception e) {
            LOG.warn("Couldn't check if model is connected: {}", e.getLocalizedMessage());
            return false;
        }
    }

    public State mapState(String roomState) {
        switch (roomState) {
            case "private", "fullprivate":
                return PRIVATE;
            case "group":
                return GROUP;
            case "public":
                return ONLINE;
            default:
                LOG.debug(roomState);
                return OFFLINE;
        }
    }

    private boolean isStreamAvailable() {
        try {
            String url = getStreamUrl();
            Request req = new Request.Builder().url(url).build();
            try (Response resp = site.getHttpClient().execute(req)) {
                if (resp.isSuccessful()) {
                    String body = Objects.requireNonNull(resp.body(), HTTP_RESPONSE_BODY_IS_NULL).string();
                    return body.contains("#EXT-X-STREAM-INF");
                } else {
                    return false;
                }
            }
        } catch (Exception e) {
            LOG.warn("Couldn't check if stream is available: {}", e.getLocalizedMessage());
            return false;
        }
    }

    private JSONObject getRoomData() throws IOException {
        String url = getSite().getBaseUrl() + "/tools/amf.php";
        RequestBody body = new FormBody.Builder()
                .add("method", "getRoomData")
                .add(ARGS, getName())
                .add(ARGS, "false")
                .build();
        Request request = newRequestBuilder()
                .url(url)
                .addHeader(ACCEPT, MIMETYPE_APPLICATION_JSON)
                .addHeader(X_REQUESTED_WITH, XML_HTTP_REQUEST)
                .post(body)
                .build();
        try (Response response = site.getHttpClient().execute(request)) {
            if (response.isSuccessful()) {
                JSONObject json = new JSONObject(Objects.requireNonNull(response.body(), HTTP_RESPONSE_BODY_IS_NULL).string());
                return json;
            } else {
                throw new IOException(response.code() + " " + response.message());
            }
        }
    }

    public void setOnline(boolean online) {
        this.online = online;
    }

    @Override
    public State getOnlineState(boolean failFast) throws IOException, ExecutionException {
        if (!failFast) {
            try {
                isOnline(true);
            } catch (InterruptedException e) {
                Thread.currentThread().interrupt();
                onlineState = OFFLINE;
            } catch (IOException | ExecutionException e) {
                onlineState = OFFLINE;
            }
        }
        return onlineState;
    }

    @Override
    public void setOnlineState(State onlineState) {
        this.onlineState = onlineState;
    }

    @Override
    public List<StreamSource> getStreamSources() throws IOException, ExecutionException, ParseException, PlaylistException {
        String streamUrl = getStreamUrl();
        Request req = newRequestBuilder().url(streamUrl).build();
        try (Response response = site.getHttpClient().execute(req)) {
            if (response.isSuccessful()) {
                InputStream inputStream = Objects.requireNonNull(response.body(), HTTP_RESPONSE_BODY_IS_NULL).byteStream();
                PlaylistParser parser = new PlaylistParser(inputStream, Format.EXT_M3U, Encoding.UTF_8, ParsingMode.LENIENT);
                Playlist playlist = parser.parse();
                MasterPlaylist master = playlist.getMasterPlaylist();
                extractStreamSources(streamUrl, master);
            } else {
                throw new HttpException(response.code(), response.message());
            }
        }
        return streamSources;
    }

    private void extractStreamSources(String streamUrl, MasterPlaylist master) {
        streamSources.clear();
        for (PlaylistData playlistData : master.getPlaylists()) {
            StreamSource streamsource = new StreamSource();
            streamsource.mediaPlaylistUrl = streamUrl.replace("playlist.m3u8", playlistData.getUri());
            if (playlistData.hasStreamInfo()) {
                StreamInfo info = playlistData.getStreamInfo();
                streamsource.bandwidth = info.getBandwidth();
                streamsource.width = info.hasResolution() ? info.getResolution().width : 0;
                streamsource.height = info.hasResolution() ? info.getResolution().height : 0;
            } else {
                streamsource.bandwidth = 0;
                streamsource.width = 0;
                streamsource.height = 0;
            }
            streamSources.add(streamsource);
        }
    }

    private String getStreamUrl() throws IOException {
        JSONObject roomData = getRoomData();
        if (roomData.optString(STATUS).equals(SUCCESS)) {
            JSONObject localData = roomData.getJSONObject("localData");
            String server = localData.getString("videoServerUrl");
            return "https:" + server + "/hls/stream_" + getName() + "/playlist.m3u8";
        } else {
            throw new IOException("Request was not successful: " + roomData.toString(2));
        }
    }

    @Override
    public void invalidateCacheEntries() {
        resolution = null;
    }

    @Override
    public void receiveTip(Double tokens) throws IOException {
        String url = getSite().getBaseUrl() + "/chat-ajax-amf-service?" + System.currentTimeMillis();
        int userId = ((BongaCamsHttpClient) site.getHttpClient()).getUserId();
        RequestBody body = new FormBody.Builder()
                .add("method", "tipModel")
                .add(ARGS, getName())
                .add(ARGS, Integer.toString(tokens.intValue()))
                .add(ARGS, Integer.toString(userId))
                .add("args[3]", "")
                .build();
        Request request = newRequestBuilder()
                .url(url)
                .addHeader(ACCEPT, MIMETYPE_APPLICATION_JSON)
                .addHeader(REFERER, getSite().getBaseUrl() + '/' + getName())
                .addHeader(X_REQUESTED_WITH, XML_HTTP_REQUEST)
                .post(body)
                .build();
        try (Response response = site.getHttpClient().execute(request)) {
            if (response.isSuccessful()) {
                JSONObject json = new JSONObject(Objects.requireNonNull(response.body(), HTTP_RESPONSE_BODY_IS_NULL).string());
                if (!json.optString(STATUS).equals(SUCCESS)) {
                    LOG.error("Sending tip failed {}", json.toString(2));
                    throw new IOException("Sending tip failed");
                }
            } else {
                throw new IOException(response.code() + ' ' + response.message());
            }
        }
    }

    @Override
    public int[] getStreamResolution(boolean failFast) throws ExecutionException {
        if (resolution == null) {
            if (failFast) {
                return new int[2];
            }
            try {
                if (!isOnline()) {
                    return new int[2];
                }
                List<StreamSource> sources = getStreamSources();
                Collections.sort(sources);
                StreamSource best = sources.get(sources.size() - 1);
                resolution = new int[]{best.width, best.height};
            } catch (InterruptedException e) {
                Thread.currentThread().interrupt();
                LOG.warn("Couldn't determine stream resolution for {} - {}", getName(), e.getMessage());
                resolution = new int[2];
            } catch (ExecutionException | IOException | ParseException | PlaylistException e) {
                LOG.warn("Couldn't determine stream resolution for {} - {}", getName(), e.getMessage());
                resolution = new int[2];
            }
        }
        return resolution;
    }

    @Override
    public boolean follow() throws IOException {
        if (!getSite().login()) {
            throw new IOException("Not logged in");
        }

        String url = getSite().getBaseUrl() + "/follow/" + getName();
        LOG.debug("Calling {}", url);
        RequestBody body = new FormBody.Builder()
                .add("src", "public-chat")
                .add("_csrf_token", getCsrfToken())
                .build();
        Request req = newRequestBuilder()
                .url(url)
                .method("POST", body)
                .header(REFERER, getUrl())
                .header(X_REQUESTED_WITH, XML_HTTP_REQUEST)
                .build();
        try (Response resp = site.getHttpClient().execute(req)) {
            if (resp.isSuccessful()) {
                String msg = Objects.requireNonNull(resp.body(), HTTP_RESPONSE_BODY_IS_NULL).string();
                JSONObject json = new JSONObject(msg);
                if (json.optBoolean(SUCCESS)) {
                    LOG.debug("Follow/Unfollow -> {}", msg);
                    return true;
                } else {
                    LOG.debug(msg);
                    throw new IOException("Response was " + msg);
                }
            } else {
                throw new HttpException(resp.code(), resp.message());
            }
        }
    }

    private String getCsrfToken() throws IOException {
        Request req = newRequestBuilder().url(getUrl()).build();
        try (Response resp = site.getHttpClient().execute(req)) {
            if (resp.isSuccessful()) {
                String content = Objects.requireNonNull(resp.body(), HTTP_RESPONSE_BODY_IS_NULL).string();
                Element html = HtmlParser.getTag(content, "html");
                String csrfToken = html.attr("data-csrf_value");
                LOG.debug("CSRF-Token {}", csrfToken);
                return csrfToken;
            } else {
                throw new HttpException(resp.code(), resp.message());
            }
        }
    }

    @Override
    public boolean unfollow() throws IOException {
        if (!getSite().login()) {
            throw new IOException("Not logged in");
        }

        String url = getSite().getBaseUrl() + "/unfollow/" + getName();
        LOG.debug("Calling {}", url);
        RequestBody body = new FormBody.Builder()
                .add("_csrf_token", getCsrfToken())
                .build();
        Request req = newRequestBuilder()
                .url(url)
                .method("POST", body)
                .header(REFERER, getUrl())
                .header(X_REQUESTED_WITH, XML_HTTP_REQUEST)
                .build();
        try (Response resp = site.getHttpClient().execute(req)) {
            if (resp.isSuccessful()) {
                String msg = Objects.requireNonNull(resp.body(), HTTP_RESPONSE_BODY_IS_NULL).string();
                JSONObject json = new JSONObject(msg);
                if (json.optBoolean(SUCCESS)) {
                    LOG.debug("Follow/Unfollow -> {}", msg);
                    return true;
                } else {
                    LOG.debug(msg);
                    throw new IOException("Response was " + msg);
                }
            } else {
                throw new HttpException(resp.code(), resp.message());
            }
        }
    }

    public void mapOnlineState(String roomState) {
        switch (roomState) {
            case "private", "fullprivate" -> setOnlineState(PRIVATE);
            case "group", "public" -> {
                setOnlineState(ONLINE);
                setOnline(true);
            }
            default -> {
                LOG.debug(roomState);
                setOnlineState(OFFLINE);
            }
        }
    }

    @Override
    public boolean exists() throws IOException {
        Request req = newRequestBuilder().url(getUrl()).build();
        try (Response response = getSite().getHttpClient().execute(req)) {
            if (!response.isSuccessful() && response.code() == 404) {
                return false;
            } else {
                return !response.request().url().toString().endsWith("_deleted");
            }
        }
    }

    private Request.Builder newRequestBuilder() {
        return new Request.Builder()
                .url(getUrl())
                .header(ACCEPT, "*/*")
                .header(ACCEPT_LANGUAGE, Locale.ENGLISH.getLanguage())
                .header(REFERER, getSite().getBaseUrl())
                .header(USER_AGENT, Config.getInstance().getSettings().httpUserAgent);
    }
}
